/****************************************/
/*		MAX4003 RFfeN^ICp			*/
/*		10LED쓮H					*/
/****************************************/
//		ADC0(PA0)MAX4003o͂dgx
//		PA1`PA7APB0`210LED_(HANeBu)
//		LED́uEChRp[^vƂA/Dlĕ\
//			A/DlɑΉLED_
//		ATTINY24Vgp
//			ROM 2k, RAM 128, EEPROM 128
//		8MHzNbN CKDEV=1/8 1MHzNbNŋN
//		Nclkpr1/2ɂ4MHzNbNœ
//		Fuse : 	Ext:0xFF H:0xDE L:0x62
//			BOD=1.8V  clock=1MHz
//		PA0 ADC0 : x 0`1.1V
//		2018-05-17	Jn
//		     05-30	ޯނL

/*****	CN[h		*****/
#include <inttypes.h>
#include <stdio.h>
#include <string.h>
#include <avr/io.h>
#include <avr/interrupt.h>
#include <avr/pgmspace.h>
#include <avr/eeprom.h> 
#include <avr/wdt.h> 

/*****	ݻނ̕ϐ`	*****/
typedef uint8_t			byte;
typedef uint16_t		word;
typedef uint32_t		lword;

/*****	zްԂϸ		*****/
#define		DIMSIZ(a)	(sizeof(a)/sizeof(*a))

/*****	fobOp	*****/
#define	PA1_ON		(PORTA |=   (1 << PA1))		// PA1 on  (12pin)
#define	PA1_OFF		(PORTA &=  ~(1 << PA1))		// PA1 off

/****************************/
/*						*/
/****************************/
//	NbN4MHz
/*****				*****/
void ioinit(void)
{
//	NbN
	CLKPR = (1 << CLKPCE);		// NbNύX
	CLKPR = 0b00000001;			// 1/8(1MHz)1/2(4MHz)
//	I/O
	PORTA = 0b00000000;		// pull upȂ
	DDRA  = 0b11111110;
	//	 	  |||||||+----	PA0 in  ADC0 x(0`1.1V)
	//		  ||||||+-----	PA1	out LED4  Hœ_
	//		  |||||+------	PA2 out LED5
	//		  ||||+-------	PA3 out LED6
	//		  |||+--------	PA4 out LED7
	//		  ||+---------	PA5 out LED8
	//		  |+----------	PA6 out LED9
	//		  +-----------	PA7 out LED10 (max)
	PORTB = 0b00000000;		// pull upȂ
	DDRB  = 0b00000111;
	//	 	       ||+----	PB0 out LED3  Hœ_
	//		       |+-----	PB1	out LED2
	//		       +------	PB2 out LED1  (min)
//	A/D
	DIDR0  = 0b00000001;
	//		          +---	ADC0D
	ADCSRA = 0b10100011;
	//		   |||||+++---	CLK 1/8 500kHz
	//		   ||||+------	ADIE
	//	       |||+-------	ADIF
	//	       ||+--------	ADATE ϊL
	//	       |+--------	ADSC
	//		   +----------	ADEN
	ADCSRB = 0b00010000;
	//		   || | +++---	free run
	//		   || |
	//		   || +-------	ADLAR l
	//		   |+---------	ACME
	//		   +----------	BIN
	ADMUX  = 0b10000000;
	//		   ||++++++---	MUX  : ch0 PA0
	//		   ++---------	REFS : 1.1V Vref
//	EIb`hbO
	wdt_reset();
	WDTCSR = 0b00011101;
	//		   ||+||+++---	WDP 0.5b
	//		   || |+------	WDE  on
	//		   || +-------	WDCE on
	//		   |+---------	WDIE ͎gȂ
	//		   +----------	WDIF
}

/****************************************/
/*		8bit A/DlLED\ϊe[u	*/
/****************************************/

/*****	LED\ϊe[u		*****/
//		A/Dl0`255PBAPA|[gf[^ɕϊ
//		޺ڰƂď(ǂꂩЂƂ_)
//		-40dBm 0.4V  0.314V   73
//		  0dBm 1.4V  1.100V  255 (8bit)
const struct{
	byte	LED_PB;		// LED 1,2,3 HŃI
	byte	LED_PA;		// LED 4`LED10
} led_port[] PROGMEM = {
//			  +-------------------	PB2 LED 1
//			  |+------------------	PB1 LED 2
//			  ||+-----------------	PB0 LED 3
//			  |||    +------------	PA7 LED 10
//			  |||	 |+-----------	PA6 LED 9
//			  |||	 ||+----------	PA5 LED 8
//			  |||	 |||+---------	PA4 LED 7
//			  |||	 ||||+--------	PA3 LED 7
//			  |||	 |||||+-------	PA2 LED 5
//			  |||	 ||||||+------	PA1 LED 4
//			  |||	 |||||||+-----	PA0 (ADC0 in)
    {  0b00000100, 0b00000000 },    //   0	LED 1 (min) HŃI
    {  0b00000010, 0b00000000 },    //   1	LED 2
    {  0b00000001, 0b00000000 },    //   2	LED 3
    {  0b00000000, 0b00000010 },    //   3	LED 4
    {  0b00000000, 0b00000100 },    //   4	LED 5
    {  0b00000000, 0b00001000 },    //   5	LED 6
    {  0b00000000, 0b00010000 },    //   6	LED 7
    {  0b00000000, 0b00100000 },    //   7	LED 8
    {  0b00000000, 0b01000000 },    //   8	LED 9
    {  0b00000000, 0b10000000 },    //   9	LED 10 (max)
};
//	LED_R[h
#define	LED_1		0
#define	LED_2		1
#define	LED_3		2
#define	LED_4		3
#define	LED_5		4
#define	LED_6		5
#define	LED_7		6
#define	LED_8		7
#define	LED_9		8
#define	LED_10		9
/*****	8bit A/Dl  LED_R[h		*****/
const byte ad_led[] PROGMEM ={
	LED_1, LED_1, LED_1, LED_1, LED_1,		//   0 `		LED1
	LED_1, LED_1, LED_1, LED_1, LED_1,		//     `@ 9
	LED_1, LED_1, LED_1, LED_1, LED_1,		//  10 `
	LED_1, LED_1, LED_1, LED_1, LED_1,		//     `@19
	LED_1, LED_1, LED_1, LED_1, LED_1,		//  20 `
	LED_1, LED_1, LED_1, LED_1, LED_1,		//     `@29
	LED_1, LED_1, LED_1, LED_1, LED_1,		//  30 `
	LED_1, LED_1, LED_1, LED_1, LED_1,		//     `@39
	LED_1, LED_1, LED_1, LED_1, LED_1,		//  40 `
	LED_1, LED_1, LED_1, LED_1, LED_1,		//     `@49
	LED_1, LED_1, LED_1, LED_1, LED_1,		//  50 `
	LED_1, LED_1, LED_1, LED_1, LED_1,		//     `@59
	LED_1, LED_1, LED_1, LED_1, LED_1,		//  60 `
	LED_1, LED_1, LED_1, LED_1, LED_1,		//     `@69
	LED_1, LED_1, LED_1, LED_1, LED_1,		//  70 `
	LED_1, LED_1, LED_1, LED_1, LED_1,		//     `  79
	LED_2, LED_2, LED_2, LED_2, LED_2,		//  80 `		LED2
	LED_2, LED_2, LED_2, LED_2, LED_2,		//     `@89
	LED_2, LED_2, LED_2, LED_2, LED_2,		//  90 `
	LED_2, LED_2, LED_2, LED_2, LED_2,		//     `@99
	LED_3, LED_3, LED_3, LED_3, LED_3,		// 100 `		LED3
	LED_3, LED_3, LED_3, LED_3, LED_3,		//     ` 109
	LED_3, LED_3, LED_3, LED_3, LED_3,		// 110 `
	LED_3, LED_3, LED_3, LED_3, LED_3,		//     ` 119
	LED_4, LED_4, LED_4, LED_4, LED_4,		// 120 `		LED4
	LED_4, LED_4, LED_4, LED_4, LED_4,		//     ` 129
	LED_4, LED_4, LED_4, LED_4, LED_4,		// 130 `
	LED_4, LED_4, LED_4, LED_4, LED_4,		//     ` 139
	LED_5, LED_5, LED_5, LED_5, LED_5,		// 140 `		LED5
	LED_5, LED_5, LED_5, LED_5, LED_5,		//     ` 149
	LED_5, LED_5, LED_5, LED_5, LED_5,		// 150 `
	LED_5, LED_5, LED_5, LED_5, LED_5,		//     ` 159
	LED_6, LED_6, LED_6, LED_6, LED_6,		// 160 `		LED6
	LED_6, LED_6, LED_6, LED_6, LED_6,		//     ` 169
	LED_6, LED_6, LED_6, LED_6, LED_6,		// 170 `
	LED_6, LED_6, LED_6, LED_6, LED_6,		//     ` 179
	LED_7, LED_7, LED_7, LED_7, LED_7,		// 180 `		LED7
	LED_7, LED_7, LED_7, LED_7, LED_7,		//     ` 189
	LED_7, LED_7, LED_7, LED_7, LED_7,		// 190 `
	LED_7, LED_7, LED_7, LED_7, LED_7,		//     ` 199
	LED_8, LED_8, LED_8, LED_8, LED_8,		// 200 `		LED8
	LED_8, LED_8, LED_8, LED_8, LED_8,		//     ` 209
	LED_8, LED_8, LED_8, LED_8, LED_8,		// 210 `
	LED_8, LED_8, LED_8, LED_8, LED_8,		//     ` 219
	LED_9, LED_9, LED_9, LED_9, LED_9,		// 220 `		LED9
	LED_9, LED_9, LED_9, LED_9, LED_9,		//     ` 229
	LED_9, LED_9, LED_9, LED_9, LED_9,		// 230 `
	LED_9, LED_9, LED_9, LED_9, LED_9,		//     ` 239
	LED_10,LED_10,LED_10,LED_10,LED_10,		// 240 `		LED10
	LED_10,LED_10,LED_10,LED_10,LED_10,		//     ` 249
	LED_10,LED_10,LED_10,LED_10,LED_10,		// 250 ` 254
	LED_10,									// 255
};

/****************************/
/*		l`hms		*/
/****************************/

/*****	l`hm			*****/
//	CPU4MHzNbNœ
//	free runłA/Dϊ\x:26.5uS(38kHz)
//	֎~̂܂܂Ŏs
int main(void)
{
byte ad_data;		// ǂݏoA/Dl
byte led;			// LED\敪
byte pa, pb;
	cli();						// ֎~
	ioinit();					// I/OƼ
	ADCSRA |= (1 << ADSC);		// A/DϊJn
								// free runȂ̂1񂾂
//	sloop
	while(1){
//	A/DϊA/DlLED\
		if(ADCSRA & (1 << ADIF)){		// A/Dϊ?
			ADCSRA |= (1 << ADIF);		// ϊ׸ނر
			ad_data  = ADCL;			// A/Dϊ(dummy)
			ad_data  = ADCH;			// A/D 8bitް
			led = pgm_read_byte(&ad_led[ad_data]); 		// ðو
			pa  = pgm_read_byte(&led_port[led].LED_PA); 	
			pb  = pgm_read_byte(&led_port[led].LED_PB); 	
			PORTA = 0b00000000;				// LEDIt
			PORTA = pa; 					// LED4`10 (HLED_)
			PORTB = 0b00000000;
			PORTB = pb; 					// LED1`3
			wdt_reset();					// ޯؾ
		}
	}
}

/*****	end of "10LED1.c"		*****/


