/****************************************/
/*		MAX4003 RFfeN^ICp			*/
/*		6LED쓮H					*/
/****************************************/
//		ADC3(PB3)MAX4003o͂dgx
//		PB0,1,2PB46LED_(HANeBu)
//		LED́uEChRp[^vƂA/Dlĕ\
//			A/DlɑΉLED_
//		ATTINY24Vgp
//			ROM 2k, RAM 128, EEPROM 128
//		8MHzNbN CKDEV=1/8 1MHzNbNŋN
//		Nclkpr1/2ɂ4MHzNbNœ
//		Fuse : 	Ext:0xFF H:0xDE L:0x62
//			BOD=1.8V  clock=1MHz
//		PB3 ADC3 : x 0`1.1V
//		PB4 com쓮@L: LED1,2,3쓮 H:LED4,5,6쓮
//		2018-05-31	Jn

/*****	CN[h		*****/
#include <inttypes.h>
#include <stdio.h>
#include <string.h>
#include <avr/io.h>
#include <avr/interrupt.h>
#include <avr/pgmspace.h>
#include <avr/eeprom.h> 
#include <avr/wdt.h> 

/*****	ݻނ̕ϐ`	*****/
typedef uint8_t			byte;
typedef uint16_t		word;
typedef uint32_t		lword;

/*****	zްԂϸ		*****/
#define		DIMSIZ(a)	(sizeof(a)/sizeof(*a))

/*****	PB4 LEDR쓮	*****/
#define	CK_COM	(PORTB & (1 << PB4))	// HȂ1

/****************************/
/*						*/
/****************************/
//	NbN4MHz
/*****				*****/
void ioinit(void)
{
//	NbN
	CLKPR = (1 << CLKPCE);		// NbNύX
	CLKPR = 0b00000001;			// 1/8(1MHz)1/2(4MHz)
//	I/O
	PORTB = 0b00000000;		// pull upȂ
	DDRB  = 0b00010111;
	//	 	     ||||+----	PB0 out LED3  Hœ_
	//		     |||+-----	PB1	out LED2
	//		     ||+------	PB2 out LED1
	//		     |+-------	PB3 in  ADC3
	//		     +--------	PB4 out LED com H/L
//	A/D
	DIDR0  = 0b00001000;
	//		       +------	ADC3D (PB3)
	ADCSRA = 0b10100011;
	//		   |||||+++---	CLK 1/8 500kHz
	//		   ||||+------	ADIE
	//	       |||+-------	ADIF
	//	       ||+--------	ADATE ϊL
	//	       |+--------	ADSC
	//		   +----------	ADEN
	ADCSRB = 0b00000000;
	//		   |||  +++---	free run
	//		   ||+--------	IPR
	//		   |+---------	ACME
	//		   +----------	BIN
	ADMUX  = 0b10100011;
	//		   ||||++++---	MUX  : ch3 PB3
	//		   ||+|-------	ADLAR l
	//		   ++-+--------	REFS : 1.1V Vref
//	EIb`hbO
	wdt_reset();
	WDTCR  = 0b00011101;
	//		   ||+||+++---	WDP 0.5b
	//		   || |+------	WDE  on
	//		   || +-------	WDCE on
	//		   |+---------	WDIE ͎gȂ
	//		   +----------	WDIF
}

/****************************************/
/*		5bit A/DlLED\ϊe[u	*/
/****************************************/

/*****	LED\ϊe[u		*****/
//		A/Dl敪0`3PB|[gf[^ɕϊ
//		޺ڰƂď(ǂꂩЂƂ_)
//		-40dBm 0.4V  0.314V   73 / 8 = 9
//		  0dBm 1.4V  1.100V  255 / 8 = 31
const byte led_port[] PROGMEM = {
//		     +--------------------	PB4 LED R H/L
//		 	 | +------------------	PB2 LED 1 (min)
//		 	 | |+-----------------	PB1 LED 2
//			 | ||+----------------	PB0 LED 3
//			 | |||
		0b00000100,			// 0 LED 1 (min)
		0b00000010,			// 1 LED 2
		0b00000001,			// 2 LED 3
		0b00010011,			// 3 LED 4
		0b00010101,			// 4 LED 5
		0b00010110,			// 5 LED 6 (max)
};

//	LED_R[h
#define	LED_1		0
#define	LED_2		1
#define	LED_3		2
#define	LED_4		3
#define	LED_5		4
#define	LED_6		5

/*****	5bit A/Dl(0`31)  LED_R[h	*****/
//	Vref=1.1V
const byte ad_led[] PROGMEM ={
	LED_1,		//   0	LED1 (min)
	LED_1,		//   1
	LED_1,		//   2
	LED_1,		//   3
	LED_1,		//   4
	LED_1,		//   5
	LED_1,		//   6
	LED_1,		//   7
	LED_1,		//   8
	LED_1,		//   9
	LED_1,		//  10
	LED_1,		//  11
	LED_2,		//  12	LED2
	LED_2,		//  13
	LED_2,		//  14
	LED_2,		//  15
	LED_3,		//  16  LED3
	LED_3,		//  17  
	LED_3,		//  18	
	LED_3,		//  19
	LED_4,		//  20  LED4
	LED_4,		//  21
	LED_4,		//  22
	LED_4,		//  23
	LED_5,		//  24  LED5 
	LED_5,		//  25	
	LED_5,		//  26
	LED_5,		//  27  
	LED_6,		//  28  LED6 
	LED_6,		//  29
	LED_6,		//  30
	LED_6,		//  31 (max)
};

/****************************/
/*		l`hms		*/
/****************************/

/*****	l`hm			*****/
//	CPU4MHzNbNœ
//	free runłA/Dϊ\x:27uS(37kHz)
//	֎~̂܂܂Ŏs
int main(void)
{
byte ad_data;
byte led;
byte pb;
	cli();						// ͋֎~
	ioinit();					// I/OƼ
	ADCSRA |= (1 << ADSC);		// A/DϊJn
								// free runȂ̂1񂾂
//	sloop
	while(1){
		wdt_reset();					// ޯؾ
//	A/DϊA/DlLED\
		if(ADCSRA & (1 << ADIF)){		// A/Dϊ?
			ADCSRA |= (1 << ADIF);		// ϊ׸ނر
			ad_data  = ADCL;			// A/Dϊ(dummy)
			ad_data  = ADCH;			// A/D 8bitް
			led = pgm_read_byte(&ad_led[ad_data / 8]); 	// 5bitɂðو
			pb  = pgm_read_byte(&led_port[led]); 	
			if(CK_COM)		PORTB = 0b00010111;	// 
			else			PORTB = 0b00000000;	// comHȂ瑼H,LȂL		
			PORTB = pb; 				// LED1`6, comɵ
			wdt_reset();				// ޯؾ
										// A/DȂγޯނؾ
		}
	}
}

/*=====	end of "6LED_TN25_1.c"		=====*/
